variables:
  SCSREL: "1.14"
  REVIEW_CONTAINER_NAME: review-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHORT_SHA} # eg: review-mulops-branch600-ca3ec109
  REVIEW_REGISTRY_IMAGE: $CI_REGISTRY_IMAGE/review
  PROD_REGISTRY_IMAGE: $CI_REGISTRY_IMAGE/prod
  DOCKER_HOST: "tcp://localhost:2375"
  DOCKER_TLS_CERTDIR: ""  # https://gitlab.com/gitlab-org/gitlab-runner/issues/4501


stages:
  - build_docker_review_image
  - deploy_review_service
  - save_docker_prod_image
  - deploy_prod_service

build_docker_review_image:
  stage: build_docker_review_image
  image: "registry.gitlab.com/gitlab-org/cluster-integration/auto-build-image/master:stable"
  services:
    - docker:stable-dind
  script:
    - echo docker build -t $REVIEW_REGISTRY_IMAGE:$SCSREL .
    - docker build -t $REVIEW_REGISTRY_IMAGE:$SCSREL .
    - echo docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
    - echo docker push $REVIEW_REGISTRY_IMAGE:$SCSREL
    - docker push $REVIEW_REGISTRY_IMAGE:$SCSREL
  except:
     - master


deploy_review_service:
  stage: deploy_review_service
  image: "registry.gitlab.com/gitlab-org/cluster-integration/auto-deploy-image:v0.1.0"
  variables:
    GIT_STRATEGY: none
  environment:
    name: review/review-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHORT_SHA}
    url: http://www.review-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHORT_SHA}.scsuk.net
    on_stop: stop_review
  script:
    - echo "Start the review deployment $REVIEW_CONTAINER_NAME"
    - echo kubectl run $REVIEW_CONTAINER_NAME --image=$REVIEW_REGISTRY_IMAGE:$SCSREL -n web
    - kubectl run $REVIEW_CONTAINER_NAME --image=$REVIEW_REGISTRY_IMAGE:$SCSREL -n web
    - echo kubectl expose deployment $REVIEW_CONTAINER_NAME --port 80 --target-port=9090 -n web
    - kubectl expose deployment $REVIEW_CONTAINER_NAME --port 80 --target-port=9090  -n web
    - sleep 10
    - kubectl get deployments -n web $REVIEW_CONTAINER_NAME
    - kubectl get services -n web $REVIEW_CONTAINER_NAME
    - kubectl get pods -o wide -n web
  except:
     - master

stop_review:
  stage: deploy_review_service
  image: "registry.gitlab.com/gitlab-org/cluster-integration/auto-deploy-image:v0.1.0"
  variables:
    GIT_STRATEGY: none
  script:
    - echo kubectl delete service $REVIEW_CONTAINER_NAME -n web
    - kubectl delete service $REVIEW_CONTAINER_NAME -n web
    - echo kubectl delete deployment $REVIEW_CONTAINER_NAME -n web
    - kubectl delete deployment $REVIEW_CONTAINER_NAME -n web
  when: manual
  environment:
    name: review/review-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHORT_SHA}
    url: http://www.review-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHORT_SHA}.scsuk.net
    action: stop
  except:
     - master

save_docker_prod_image:
  stage: save_docker_prod_image
  image: "registry.gitlab.com/gitlab-org/cluster-integration/auto-build-image/master:stable"
  variables:
    GIT_STRATEGY: none
  services:
    - docker:stable-dind
  script:
    - docker ps
    - docker image ls
    - echo docker pull $REVIEW_REGISTRY_IMAGE:$SCSREL
    - docker image ls
    - docker pull $REVIEW_REGISTRY_IMAGE:$SCSREL
    - echo docker tag $REVIEW_REGISTRY_IMAGE:$SCSREL $PROD_REGISTRY_IMAGE:$SCSREL
    - docker tag $REVIEW_REGISTRY_IMAGE:$SCSREL $PROD_REGISTRY_IMAGE:$SCSREL
    - echo docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
    - echo docker push $PROD_REGISTRY_IMAGE:$SCSREL
    - docker push $PROD_REGISTRY_IMAGE:$SCSREL
  only:
     - master

deploy_prod_service:
  stage: deploy_prod_service
  image: "registry.gitlab.com/gitlab-org/cluster-integration/auto-deploy-image:v0.1.0"
  script:
    - echo ./deploy_prod_service.sh ${CI_PROJECT_NAME}
    - ./deploy_prod_service.sh ${CI_PROJECT_NAME}
  environment:
    name: production
    url: http://www.prometheus.scsuk.net
  when: manual
  only:
     - master

